
Ruby - Bug #17876

Backport dfe21ef7a15a30fc33f3a5cc089e15d09e905eb4 to Ruby 3.0

05/21/2021 04:29 AM - k0kubun (Takashi Kokubun)

Status: Closed   

Priority: Normal   

Assignee: nagachika (Tomoyuki Chikanaga)   

Target version:    

ruby -v:  Backport: 2.6: DONTNEED, 2.7: DONTNEED, 3.0:

DONE

Description

Please consider backporting dfe21ef7a15a30fc33f3a5cc089e15d09e905eb4 to ruby_3_0. This is a fix for a bug introduced in Ruby

3.0.

Associated revisions

Revision e175917f66f0b51638d9d9e143918d4109d489f4 - 05/22/2021 05:59 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) dfe21ef7a15a30fc33f3a5cc089e15d09e905eb4: [Backport #17874] [Backport #17876]

    Do not block JIT with pending_stale_p

    Because we want to flush pending stale units before unloading units, the

    pending_stale_p check is implemented in this waiting loop.

    However, once all methods are called more than --jit-min-calls,

    mjit_worker_wakeup will not be signaled again. As a result, when

    mjit_recompile is called after that and pending_stale_p becomes true,

    MJIT stops processing methods in the unit queue even if the queue is

    very long and MJIT does nothing, waiting for the signal.

    There should be a better way to handle this, but as a fix to be

    backported to Ruby 3.0, let me make an obvious simple commit here.

    ---

     mjit_worker.c | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)

Revision e175917f66f0b51638d9d9e143918d4109d489f4 - 05/22/2021 05:59 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) dfe21ef7a15a30fc33f3a5cc089e15d09e905eb4: [Backport #17874] [Backport #17876]

    Do not block JIT with pending_stale_p

    Because we want to flush pending stale units before unloading units, the

    pending_stale_p check is implemented in this waiting loop.

    However, once all methods are called more than --jit-min-calls,

    mjit_worker_wakeup will not be signaled again. As a result, when

    mjit_recompile is called after that and pending_stale_p becomes true,

    MJIT stops processing methods in the unit queue even if the queue is

    very long and MJIT does nothing, waiting for the signal.

    There should be a better way to handle this, but as a fix to be

    backported to Ruby 3.0, let me make an obvious simple commit here.

    ---

     mjit_worker.c | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)

Revision e175917f - 05/22/2021 05:59 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) dfe21ef7a15a30fc33f3a5cc089e15d09e905eb4: [Backport #17874] [Backport #17876]

    Do not block JIT with pending_stale_p

    Because we want to flush pending stale units before unloading units, the

    pending_stale_p check is implemented in this waiting loop.

    However, once all methods are called more than --jit-min-calls,
    mjit_worker_wakeup will not be signaled again. As a result, when

    mjit_recompile is called after that and pending_stale_p becomes true,

    MJIT stops processing methods in the unit queue even if the queue is

    very long and MJIT does nothing, waiting for the signal.

    There should be a better way to handle this, but as a fix to be

    backported to Ruby 3.0, let me make an obvious simple commit here.

    ---

     mjit_worker.c | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)

History

#1 - 05/21/2021 04:39 AM - nagachika (Tomoyuki Chikanaga)

- Status changed from Open to Closed

I will close this ticket to trigger backport request notice.

To tell the truth, I already file a backport ticket for the changests ;) https://bugs.ruby-lang.org/issues/17874

Anyway Thank you for your clarify.

#2 - 05/21/2021 06:48 AM - k0kubun (Takashi Kokubun)

You beat me :) Thanks!

#3 - 05/22/2021 05:59 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.6: DONTNEED, 2.7: DONTNEED, 3.0: REQUIRED to 2.6: DONTNEED, 2.7: DONTNEED, 3.0: DONE

ruby_3_0 e175917f66f0b51638d9d9e143918d4109d489f4 merged revision(s) dfe21ef7a15a30fc33f3a5cc089e15d09e905eb4.
